SQUASHFS_VERSION:=2.2-r2
SQUASHFS_SOURCE:=squashfs$(SQUASHFS_VERSION).tar.gz
SQUASHFS_SOURCE_MD5:=a8d09a217240127ae4d339e8368d2de1
SQUASHFS_SITE:=@SF/squashfs

SQUASHFS_MAKE_DIR:=$(TOOLS_DIR)/make
SQUASHFS_DIR:=$(TOOLS_SOURCE_DIR)/squashfs$(SQUASHFS_VERSION)
SQUASHFS_BUILD_DIR:=$(SQUASHFS_DIR)/squashfs-tools

SQUASHFS_TOOLS:=mksquashfs-lzma unsquashfs-lzma
SQUASHFS_TOOLS_BUILD_DIR:=$(addprefix $(SQUASHFS_BUILD_DIR)/,$(SQUASHFS_TOOLS))
SQUASHFS_TOOLS_TARGET_DIR:=$(addprefix $(TOOLS_DIR)/,$(SQUASHFS_TOOLS))

$(DL_DIR)/$(SQUASHFS_SOURCE): | $(DL_DIR)
	$(DL_TOOL) $(DL_DIR) $(SQUASHFS_SOURCE) $(SQUASHFS_SITE) $(SQUASHFS_SOURCE_MD5)

$(SQUASHFS_DIR)/.unpacked: $(DL_DIR)/$(SQUASHFS_SOURCE) | $(TOOLS_SOURCE_DIR)
	tar -C $(TOOLS_SOURCE_DIR) $(VERBOSE) -xf $(DL_DIR)/$(SQUASHFS_SOURCE)
	for i in $(SQUASHFS_MAKE_DIR)/patches/*.squashfs.patch; do \
		$(PATCH_TOOL) $(SQUASHFS_DIR) $$i; \
	done
	touch $@

$(SQUASHFS_TOOLS_BUILD_DIR): $(SQUASHFS_DIR)/.unpacked $(LZMA_DIR)/liblzma.a
	$(MAKE) CC="$(TOOLS_CC)" CXX="$(TOOLS_CXX)" LZMA_DIR="$(abspath $(LZMA_DIR))" \
		-C $(SQUASHFS_BUILD_DIR) $(SQUASHFS_TOOLS)
	touch -c $@

$(SQUASHFS_TOOLS_TARGET_DIR): $(TOOLS_DIR)/%: $(SQUASHFS_BUILD_DIR)/%
	cp $^ $@
	strip $@

squashfs: $(SQUASHFS_TOOLS_TARGET_DIR)

squashfs-source: $(SQUASHFS_DIR)/.unpacked

squashfs-clean:
	-$(MAKE) -C $(SQUASHFS_BUILD_DIR) clean

squashfs-dirclean:
	$(RM) -r $(SQUASHFS_DIR)

squashfs-distclean: squashfs-dirclean
	$(RM) $(SQUASHFS_TOOLS_TARGET_DIR)
